function out = LogMap
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = [];
out{9} = [];

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,mu)
dydt=[mu*kmrgd(1)*(1-kmrgd(1));];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(LogMap);
y0=[0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,mu)
jac=[ - mu*kmrgd(1) - mu*(kmrgd(1) - 1) ];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,mu)
jacp=[ -kmrgd(1)*(kmrgd(1) - 1) ];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,mu)
hess1=[ -2*mu ];
hess(:,:,1) =hess1;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,mu)
hessp1=[ 1 - 2*kmrgd(1) ];
hessp(:,:,1) =hessp1;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,mu)
tens31=[ 0 ];
tens3(:,:,1,1) =tens31;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,mu)
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,mu)
